<template>
  <div>
    <alert-thumbnail-gallery
      v-if="alertsFiltered.length"
      :alerts="alertsFiltered"
    />
  </div>
</template>

<script>
/* eslint-disable func-names, @typescript-eslint/no-this-alias, prefer-rest-params,
  no-param-reassign, no-restricted-globals, no-underscore-dangle
*/

/*
TODO: this currently hard-codes the chart group to "default". I would
like to get the chart group from the view properties, but I don't know how
to do that in Vue.
*/
import Vue from 'vue';
import * as charts from '@/vis/chartTyped';
import AlertThumbnailGallery from './AlertThumbnailGallery.vue';

// https://stackoverflow.com/a/24004942
function debounce(func, wait, immediate) {
  let timeout;

  return function () {
    const context = this;
    const args = arguments;

    const callNow = immediate && !timeout;

    clearTimeout(timeout);

    timeout = setTimeout(() => {
      timeout = null;

      if (!immediate) {
        func.apply(context, args);
      }
    }, wait);

    if (callNow) func.apply(context, args);
  };
}

export default Vue.extend({
  components: {
    AlertThumbnailGallery,
  },

  props: {
    locus: {
      type: Object,
      default: () => ({}),
    },
  },

  computed: {
    alertsFiltered() {
      const predicate = charts.getSelectionPredicate('default', 'table');

      // here, we're working around a vue problem where filtering on managed data is
      // much slower than expected because of dependency tracking.
      //
      // 2021-04-13: however, _somehow_ this.nonReactiveLightcurve apparently ends up with _some_
      // reactive elements?! Specifically, entries that are actual corrected magnitude entries end
      // up becoming reactive elements on this.nonReactiveLightcurve after alerts is loaded.
      //
      // this doesn't make our code _wrong_, but it does make it slow and it has befuddled me.

      const alerts = (this.nonReactiveLightcurve || []).filter((el) => {
        el = { ...el };
        return (
          !isNaN(el.frontend_mag)
          && predicate({
            payload: el,
            type: 'mag',
            getMag() {
              return this.payload.frontend_mag;
            },
          })
        );
      });
      return alerts.map((el) => ({
        id: el.alert_id,
        mjd: el.ant_mjd,
        properties: { ...el },
      }));
    },
  },

  mounted() {
    const that = this;
    this.nonReactiveLightcurve = Array.from(this.locus.lightcurve).map((el) => ({ ...el }));

    this.$forceUpdate(); // ugly, but necessary for alertsFiltered() to work.

    charts.chartStore.commit('predicate', {
      group: 'default',
      chartName: 'table',
      predicate: null,
    });
    // we debounce the table update at 10Hz to minimize jankiness.
    // A perceptive reader will also note that this is a
    // massive hack. The Vue deities are displeased.
    const debounced = debounce(
      () => {
        if (that._computedWatchers.alertsFiltered) {
          that._computedWatchers.alertsFiltered.run();
          that.$forceUpdate();
        }
      },
      100,
      false,
    );
    charts.watchBrush('default', debounced);
  },
});
</script>

<style scoped>
  >>> .table {
    table-layout: fixed;
  }
</style>
